#include <time.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <arpa/inet.h>
#include <string.h>
#include <stdbool.h>
#include <unistd.h>

int MIN_DELAY = 4;
int SAFETY_MARGIN = 0;
int TIMEOUT = 3;

int main(int argc, char* argv[])
{
    char *ip = NULL;
    int port = 0;
    char opt;
    while ((opt = getopt(argc, argv, "i:p:")) != -1) {
        switch (opt) {
        case 'i': ip = optarg; break;
        case 'p': port = atoi(optarg); break;
        default:
            fprintf(stderr, "Usage: %s -i IP -d device -p port [-f]\n", argv[0]);
            exit(EXIT_FAILURE);
        }
    }

    if (!ip || !port) {
	fprintf(stderr, "1Usage: %s -i destination IP -p destination port\n", argv[0]);
        exit(EXIT_FAILURE);
    }

    int fd = socket(AF_INET, SOCK_DGRAM,0);
    if (fd <= 0) {
        printf("socket: socket\n");
        exit(EXIT_FAILURE);
    }
    
    struct sockaddr_in v_dst = {};
    inet_pton(AF_INET, ip, &v_dst.sin_addr.s_addr);
    v_dst.sin_port = htons(port);
    v_dst.sin_family = AF_INET;
    
    if (bind(fd, (struct sockaddr*) &v_dst, sizeof(struct sockaddr_in)) != 0) {
            char s[100];
            sprintf(s, "bind to addr %s", ip);
            perror(s);
        exit(EXIT_FAILURE);
    }
  
    char buf[10];
    int len = 10;
    struct sockaddr_in from;
    socklen_t fromlen = sizeof(from);
    if (recvfrom(fd, buf, len, 0, (struct sockaddr*) &from, &fromlen) == -1) {
        perror("recv");
        exit(EXIT_FAILURE);
    }
    printf("received message %s\n", buf);
    sleep(MIN_DELAY); //pre sleep
    printf("First sleep: %ims\n", MIN_DELAY*1000);
    srand (time(NULL));
    int sl = rand()%((TIMEOUT-MIN_DELAY-SAFETY_MARGIN)*1001);
    printf("Second sleep: %ims\n", sl);
    usleep(sl*1000);
    struct sockaddr_in* addr = &from;
    printf("IP Address is : %s\n", inet_ntoa(addr->sin_addr));
    if (sendto(fd, "pong", 4, 0, (struct sockaddr*) &from, fromlen) != 5) {
	perror("sento");
	exit(EXIT_FAILURE);
    }     
}
